<?php
namespace WPT\FaqManager\Blocks\FaqList;

/**
 * Attributes.
 */
class Attributes
{
    protected $container;

    public function get_attributes()
    {
        $attributes = $this->general_attributes()
         + $this->open_close()
         + $this->icon()
         + $this->category_title()
         + $this->faq_list_wrapper()
         + $this->faq_item_wrapper()
         + $this->question()
         + $this->answer()
         + $this->filtering_options();

        return $attributes;
    }

    public function answer()
    {
        return [
            'answerMargin'  => [
                'type'    => 'object',
                'default' => [
                    'top'        => '0',
                    'right'      => '0',
                    'bottom'     => '0',
                    'left'       => '0',
                    'equalSpace' => false,
                ],
            ],
            'answerPadding' => [
                'type'    => 'object',
                'default' => [
                    'top'        => '20px',
                    'right'      => '0',
                    'bottom'     => '20px',
                    'left'       => '0',
                    'equalSpace' => false,
                ],
            ],
        ];
    }

    public function question()
    {
        return [
            'questionPadding'    => [
                'type'    => 'object',
                'default' => [
                    'top'        => '0',
                    'right'      => '0',
                    'bottom'     => '0',
                    'left'       => '0',
                    'equalSpace' => false,
                ],
            ],
            'questionMargin'     => [
                'type'    => 'object',
                'default' => [
                    'top'        => '0',
                    'right'      => '0',
                    'bottom'     => '20px',
                    'left'       => '0',
                    'equalSpace' => false,
                ],
            ],
            'questionBorder'     => [
                'type'    => 'object',
                'default' => [
                    'width'      => [
                        'top'    => "0",
                        'right'  => "0",
                        'bottom' => "1px",
                        'left'   => "0",
                    ],
                    'color'      => '#f0f1f5',
                    'style'      => 'solid',
                    'equalWidth' => false,
                ],
            ],

            'questionTypography' => [
                'type'    => 'object',
                'default' => [
                    "fontFamily"    => ['label' => 'inherit', 'value' => 'inherit', 'google' => false],
                    "fontSize"      => "17px",
                    "fontWeight"    => "normal",
                    "fontStyle"     => "normal",
                    "lineHeight"    => "normal",
                    "letterSpacing" => "normal",
                    "wordSpacing"   => "normal",
                    "textAlign"     => "left",
                    "textTransform" => "none",
                    "color"         => "#2f3b48",

                ],
            ],
        ];
    }

    public function faq_item_wrapper()
    {
        return [
            'faqItemMargin'  => [
                'type'    => 'object',
                'default' => [
                    'top'        => '0',
                    'right'      => '0',
                    'bottom'     => '20px',
                    'left'       => '0',
                    'equalSpace' => false,
                ],
            ],
            'faqItemPadding' => [
                'type'    => 'object',
                'default' => [
                    'top'        => '0',
                    'right'      => '0',
                    'bottom'     => '0',
                    'left'       => '0',
                    'equalSpace' => true,
                ],
            ],

            'faqItemBorder'  => [
                'type'    => 'object',
                'default' => [
                    'width'      => [
                        'top'    => "0",
                        'right'  => "0",
                        'bottom' => "0",
                        'left'   => "0",
                    ],
                    'color'      => '#ffffff',
                    'style'      => 'solid',
                    'equalWidth' => false,
                ],
            ],

        ];
    }

    public function faq_list_wrapper()
    {
        return [
            'faqListWrapperMargin'  => [
                'type'    => 'object',
                'default' => [
                    'top'        => '0',
                    'right'      => '0',
                    'bottom'     => '0',
                    'left'       => '0',
                    'equalSpace' => true,
                ],
            ],
            'faqListWrapperPadding' => [
                'type'    => 'object',
                'default' => [
                    'top'        => '0',
                    'right'      => '0',
                    'bottom'     => '0',
                    'left'       => '0',
                    'equalSpace' => true,
                ],
            ],

            'faqListWrapperBorder'  => [
                'type'    => 'object',
                'default' => [
                    'width'      => [
                        'top'    => "0",
                        'right'  => "0",
                        'bottom' => "0",
                        'left'   => "0",
                    ],
                    'color'      => '#ffffff',
                    'style'      => 'solid',
                    'equalWidth' => true,
                ],
            ],
        ];
    }

    public function category_title()
    {
        return [
            'categoryTitleMargin'     => [
                'type'    => 'object',
                'default' => [
                    'top'        => '0',
                    'right'      => '0',
                    'bottom'     => '0',
                    'left'       => '0',
                    'equalSpace' => true,
                ],
            ],
            'categoryTitlePadding'    => [
                'type'    => 'object',
                'default' => [
                    'top'        => '20px',
                    'right'      => '0',
                    'bottom'     => '20px',
                    'left'       => '0',
                    'equalSpace' => false,
                ],
            ],
            'category_name_html_tag'  => [
                'type'    => 'string',
                'default' => 'h3',
            ],
            'categoryTitleTypography' => [
                'type'    => 'object',
                'default' => [
                    "fontFamily"    => ['label' => 'inherit', 'value' => 'inherit', 'google' => false],
                    "fontSize"      => "22px",
                    "fontWeight"    => "700",
                    "fontStyle"     => "normal",
                    "lineHeight"    => "1.5em",
                    "letterSpacing" => "1px",
                    "wordSpacing"   => "normal",
                    "textAlign"     => "left",
                    "textTransform" => "uppercase",
                    "color"         => "#000000",
                ],
            ],

        ];
    }

    public function icon()
    {
        return [
            'icon_placement'   => [
                'type'    => 'string',
                'default' => 'left',
            ],
            'icon_set'         => [
                'type'    => 'string',
                'default' => 'plus-minus',
            ],
            'icon_color_open'  => [
                'type'    => 'string',
                'default' => '#4c8bf5',
            ],
            'icon_color_close' => [
                'type'    => 'string',
                'default' => '#4c8bf5',
            ],
        ];
    }

    public function open_close()
    {
        return [
            'expand'   => [
                'type'    => 'boolean',
                'default' => false,
            ],
            'can_open' => [
                'type'    => 'string',
                'default' => 'one',
            ],
        ];
    }

    public function filtering_options()
    {
        $attributes = [
            'filterByCategories' => [
                'type'    => 'boolean',
                'default' => false,
            ],
            'groupByCategories'  => [
                'type'    => 'boolean',
                'default' => true,
            ],
            'categories'         => [
                'type'    => 'array',
                'default' => [],
                'items'   => [
                    'type' => 'integer',
                ],
            ],
            'post__in'           => [
                'type'    => 'string',
                'default' => '',
            ],

            'post__not_in'       => [
                'type'    => 'string',
                'default' => '',
            ],

            'faqs_per_page'      => [
                'type'    => 'integer',
                'default' => -1,
            ],

            'orderby'            => [
                'type'    => 'string',
                'default' => 'date',
            ],
            'order'              => [
                'type'    => 'string',
                'default' => 'ASC',
            ],
        ];

        return $attributes;
    }

    public function general_attributes()
    {
        $attributes = [
            'cssId'           => [
                'type'    => 'string',
                'default' => 'faq-list',
            ],
            'isPremium'       => [
                'type'    => 'boolean',
                'default' => false,
            ],
            'className'       => [
                'type'    => 'string',
                'default' => '',
            ],

            'loadGoogleFonts' => [
                'type'    => 'boolean',
                'default' => false,
            ],

        ];

        return $attributes;
    }

}
