<?php
namespace WPT\FaqManager\Blocks\Styles;

/**
 *
 */
class Spacing {
    use DefaultComponentFunctions;

    public function __construct($cssName, $attributeName, $consolidate = true) {
        $this->cssName       = $cssName;
        $this->attributeName = $attributeName;
        $this->consolidate   = $consolidate;
        $this->cssVars       = [];
    }

    public function getCssVariablesArray() {
        $values = $this->getAttributeValues();
        if (isset($values['equalSpace'])) {
            unset($values['equalSpace']);
        }

        $vars = [];

        if ($this->consolidate) {
            $vars[$this->cssName] = sprintf('%s %s %s %s', $values['top'], $values['right'], $values['bottom'], $values['left']);

        } else {
            foreach ($values as $key => $value) {
                $vars[sprintf('%s-%s', $this->cssName, $key)] = $values[$key];
            }
        }

        return $vars;
    }
}
