<?php
namespace WPT\FaqManager\Blocks\Styles;

/**
 *
 */
class Typography {
    use DefaultComponentFunctions;

    public function __construct($cssName, $attributeName) {
        $this->cssName       = $cssName;
        $this->attributeName = $attributeName;
        $this->cssVars       = [];
    }

    public function getCssVariablesArray() {
        $values = $this->getAttributeValues();

        $vars = [];

        foreach ($values as $key => $value) {
            switch ($key) {
            case 'fontFamily':
                $vars[sprintf('%s-%s', $this->cssName, 'ff')] = $values['fontFamily']['value'];
                if ($values['fontFamily']['google']) {
                    GoogleFonts::$fontFamilies[] = urlencode($values['fontFamily']['value']);
                }
                break;

            case 'fontSize':
                $vars[sprintf('%s-%s', $this->cssName, 'fsize')] = $values['fontSize'];
                break;

            case 'fontWeight':
                $vars[sprintf('%s-%s', $this->cssName, 'fw')] = $values['fontWeight'];
                break;

            case 'fontStyle':
                $vars[sprintf('%s-%s', $this->cssName, 'fs')] = $values['fontStyle'];
                break;

            case 'lineHeight':
                $vars[sprintf('%s-%s', $this->cssName, 'lh')] = $values['lineHeight'];
                break;

            case 'letterSpacing':
                $vars[sprintf('%s-%s', $this->cssName, 'ls')] = $values['letterSpacing'];
                break;

            case 'wordSpacing':
                $vars[sprintf('%s-%s', $this->cssName, 'ws')] = $values['wordSpacing'];
                break;

            case 'textAlign':
                $vars[sprintf('%s-%s', $this->cssName, 'ta')] = $values['textAlign'];
                break;

            case 'textTransform':
                $vars[sprintf('%s-%s', $this->cssName, 'tt')] = $values['textTransform'];
                break;

            case 'color':
                $vars[sprintf('%s-%s', $this->cssName, 'c')] = $values['color'];
                break;

            case 'colorHover':
                $vars[sprintf('%s-%s', $this->cssName, 'ch')] = $values['colorHover'];
                break;

            default:
                # code...
                break;
            }
        }

        return $vars;
    }
}
