<?php

namespace WPT\FaqManager;

use  Pimple\Container ;
/**
 * Container
 */
class Loader extends Container
{
    /**
     *
     * @var mixed
     */
    public static  $instance ;
    public function __construct()
    {
        parent::__construct();
        $this['bootstrap'] = function ( $container ) {
            return new WP\Bootstrap( $container );
        };
        $this['faq_post_type'] = function ( $container ) {
            return new WP\PostType\Faq( $container );
        };
        $this['faq_accordion_shortcode'] = function ( $container ) {
            return new WP\Shortcodes\FaqAccordion( $container );
        };
        $this['divi'] = function ( $container ) {
            return new Divi\Divi( $container );
        };
        $this['faq_list_block'] = function ( $container ) {
            return new Blocks\FaqList\Block( $container );
        };
        $this['block_renderer'] = function ( $container ) {
            return new Blocks\WP_REST_Block_Renderer_Controller( $container );
        };
    }
    
    /**
     * Get container instance.
     */
    public static function getInstance()
    {
        if ( !self::$instance ) {
            self::$instance = new Loader();
        }
        return self::$instance;
    }
    
    /**
     * Plugin run
     */
    public function run()
    {
        // divi
        $this['divi']->init();
        // rest api for blocks
        add_action( 'rest_api_init', [ $this['bootstrap'], 'rest_init' ], -999 );
        // $this['bootstrap']->rest_init();
        // blocks
        require_once $this['plugin_dir'] . '/blocks/faq-list/faq-list.php';
        add_action( 'rest_api_init', [ $this['block_renderer'], 'register_routes' ] );
        $container = $this;
        add_action( 'admin_enqueue_scripts', function () use( $container ) {
            wp_register_style( 'wpt-faq-accordion-placeholder', false );
            wp_enqueue_style( 'wpt-faq-accordion-placeholder' );
            wp_enqueue_style( 'wpt-faq-accordion-style', $container['plugin_url'] . '/styles/faq-accordion/style.css', [ 'wpt-faq-accordion-placeholder' ] );
        }, 10 );
        // freemius license setup
        add_action( 'admin_head', [ $this['bootstrap'], 'set_freemius_license_javascript_var' ] );
        // plugin admin menu
        add_action( 'admin_menu', [ $this['bootstrap'], 'admin_menu' ] );
        add_action( 'admin_bar_menu', [ $this['bootstrap'], 'admin_bar_menu' ], 999 );
        add_action( 'admin_head', [ $this['bootstrap'], 'admin_head' ] );
        // post type
        $this['bootstrap']->register_post_types();
        // shortcodes
        add_shortcode( 'wpt_faqs', [ $this['faq_accordion_shortcode'], 'render' ] );
        add_action( 'enqueue_wpt_faq_shortcode_assets', [ $this['faq_accordion_shortcode'], 'enqueue_assets' ] );
        // structured data.
        add_action(
            'wpt_faq_structured_data',
            [ $this['faq_post_type'], 'get_structured_data' ],
            10,
            1
        );
    }

}