<?php

use  WPT\FaqManager\Divi\Components\Border ;
use  WPT\FaqManager\Divi\Components\MarginPadding ;
class FMFD_FaqManagerFaqModule extends ET_Builder_Module
{
    public  $slug = 'et_pb_fmfd_faq_module' ;
    public  $vb_support = 'on' ;
    protected  $module_credits = array(
        'module_uri' => 'https://wptools.app/wordpress-plugins/faq-manager-with-structured-data/?utm_source=divi-module&utm_medium=page&utm_campaign=faq-divi&utm_content=free',
        'author'     => 'WP Tools → Get 7 day FREE Trial',
        'author_uri' => 'https://wptools.app/wordpress-plugins/faq-manager-with-structured-data/?utm_source=divi-module&utm_medium=page&utm_campaign=faq-divi&utm_content=free#pricing',
    ) ;
    public function __construct()
    {
        parent::__construct();
    }
    
    /**
     * Initialization
     */
    public function init()
    {
        $this->name = esc_html__( 'Faq List', 'fmfd-faq-module-for-divi-theme' );
        $this->set_module_advanced_fields();
        $this->set_module_modal_toggles();
    }
    
    /**
     * Modal toggles
     */
    public function set_module_modal_toggles()
    {
        $this->settings_modal_toggles = [
            'general'  => [
            'settings' => [
            'toggles_disabled' => true,
        ],
            'toggles'  => [
            'faq-filter'          => esc_html__( 'Filtering Options', 'et_builder' ),
            'open-close-behavior' => esc_html__( 'Open-Close Behavior', 'et_builder' ),
        ],
        ],
            'advanced' => [
            'settings' => [
            'toggles_disabled' => true,
        ],
            'toggles'  => [
            'faq-icon'         => 'Icon',
            'category_title'   => [
            'title'   => 'Category Title',
            'show_if' => [
            'filter_by_categories' => 'on',
        ],
        ],
            'faq_list'         => 'FAQ List Wrapper',
            'faq_item'         => 'FAQ Item Wrapper',
            'faq_question'     => 'Question',
            'faq_answer'       => 'Answer',
            'browser_behavior' => 'Browser Behavior',
        ],
        ],
        ];
    }
    
    /**
     * Setup advanced fields.
     */
    public function set_module_advanced_fields()
    {
        $this->advanced_fields = [
            'margin_padding' => [
            'css' => [
            'important' => [ 'custom_margin' ],
        ],
        ],
            'background'     => false,
            'border'         => false,
            'borders'        => false,
            'box_shadow'     => [
            'default' => [
            'css'         => [
            'important'    => 'all',
            'main'         => '%%order_class%% .wpt-faq-item',
            'custom_style' => true,
        ],
            'tab_slug'    => 'advanced',
            'toggle_slug' => 'faq_item',
        ],
        ],
            'max_width'      => false,
            'fonts'          => [
            'category_title' => [
            'label'          => esc_html__( 'Category Title', 'et_builder' ),
            'show_if'        => [
            'filter_by_categories' => 'on',
            'group_by_categories'  => 'on',
        ],
            'css'            => [
            'important' => 'all',
            'main'      => "{$this->main_css_element} .wpt-faq-category",
        ],
            'header_level'   => [
            'default' => $this->get_default( 'category_name_html_tag' ),
        ],
            'font_size'      => [
            'default' => $this->get_default( 'category_title_font_size' ),
        ],
            'font'           => [
            'default' => $this->get_default( 'category_title_font' ),
        ],
            'line_height'    => [
            'default' => $this->get_default( 'category_title_line_height' ),
        ],
            'letter_spacing' => [
            'default' => $this->get_default( 'category_title_letter_spacing' ),
        ],
            'text_color'     => [
            'default' => $this->get_default( 'category_title_text_color' ),
        ],
            'text_align'     => [
            'default' => $this->get_default( 'category_title_text_align' ),
            'options' => et_builder_get_text_orientation_options( [ 'justified' ], [] ),
        ],
        ],
            'faq_question'   => [
            'label'      => esc_html__( 'FAQ Question Title', 'et_builder' ),
            'css'        => [
            'main' => "{$this->main_css_element} .wpt-faq-question-text",
        ],
            'font_size'  => [
            'default' => $this->get_default( 'question_font_size' ),
        ],
            'text_color' => [
            'default'  => $this->get_default( 'question_text_color' ),
            'priority' => 3,
            'label'    => 'Text Color - FAQ Close',
        ],
            'text_align' => [
            'default' => $this->get_default( 'question_text_align' ),
            'options' => et_builder_get_text_orientation_options( [ 'justified' ], [] ),
        ],
        ],
        ],
            'text'           => false,
            'button'         => false,
            'filters'        => false,
            'animation'      => false,
            'text_shadow'    => false,
            'link_options'   => false,
        ];
    }
    
    /**
     * Divi module fields.
     */
    public function get_fields()
    {
        $margin_padding = new MarginPadding();
        $border = new Border();
        $fields = [];
        $fields['faqs_per_page'] = [
            'label'          => esc_html__( 'Number of FAQs to fetch', 'et_builder' ),
            'type'           => 'range',
            'range_settings' => [
            'min'  => -1,
            'max'  => 10000,
            'step' => 1,
        ],
            'tab_slug'       => 'general',
            'toggle_slug'    => 'faq-filter',
            'description'    => esc_html__( 'Number of faq`s to fetch. -1 fetch`s all.', 'et_builder' ),
            'validate_unit'  => false,
            'allowed_units'  => [ '' ],
            'default_unit'   => '',
            'default'        => $this->get_default( 'faqs_per_page' ),
        ];
        $fields['orderby'] = [
            'label'       => esc_html__( 'Order FAQs By', 'et_builder' ),
            'type'        => 'select',
            'options'     => [
            'none'       => 'No order',
            'ID'         => 'Order By FAQ ID',
            'author'     => 'Order by author',
            'title'      => 'Order by faq question',
            'name'       => 'Order by faq slug',
            'date'       => 'Order by date',
            'modified'   => 'Order by last modified date',
            'rand'       => 'Random order',
            'menu_order' => 'Order by Page Order (Premium only)',
            'post__in'   => 'Preserve FAQ ID order given in the post__in (Premium only)',
        ],
            'tab_slug'    => 'general',
            'toggle_slug' => 'faq-filter',
            'description' => esc_html__( 'Select the option for ordering FAQ', 'et_builder' ),
            'show_if'     => [],
            'default'     => $this->get_default( 'orderby' ),
        ];
        $fields['order'] = [
            'label'       => esc_html__( 'Order Direction', 'et_builder' ),
            'type'        => 'select',
            'options'     => [
            'ASC'  => 'Ascending',
            'DESC' => 'Descending',
        ],
            'tab_slug'    => 'general',
            'toggle_slug' => 'faq-filter',
            'description' => esc_html__( 'Select the direction to be either ascending or descending', 'et_builder' ),
            'show_if'     => [],
            'default'     => $this->get_default( 'order' ),
        ];
        $fields['expand'] = [
            'label'       => esc_html__( 'Expand FAQ`s By Default', 'et_builder' ),
            'type'        => 'yes_no_button',
            'options'     => [
            'off' => esc_html__( 'Off', 'et_builder' ),
            'on'  => esc_html__( 'On', 'et_builder' ),
        ],
            'tab_slug'    => 'general',
            'toggle_slug' => 'open-close-behavior',
            'description' => esc_html__( 'Expand all faqs by default. Default is off', 'et_builder' ),
            'show_if'     => [],
            'default'     => $this->get_default( 'expand' ),
        ];
        $fields['can_open'] = [
            'label'       => esc_html__( 'Number of faqs open at once', 'et_builder' ),
            'type'        => 'select',
            'options'     => [
            'one'  => 'One',
            'many' => 'Many',
        ],
            'tab_slug'    => 'general',
            'toggle_slug' => 'open-close-behavior',
            'description' => esc_html__( 'Select `one` to keep only one faq open at a given time. Select `many` to keep multiple faqs open at once', 'et_builder' ),
            'show_if'     => [
            'expand' => 'off',
        ],
            'default'     => $this->get_default( 'can_open' ),
        ];
        $fields['icon_placement'] = [
            'label'       => esc_html__( 'Icon Placement', 'et_builder' ),
            'type'        => 'select',
            'options'     => [
            'left'  => 'Left',
            'right' => 'Right',
            'none'  => 'None (Hide Icon)',
        ],
            'tab_slug'    => 'advanced',
            'toggle_slug' => 'faq-icon',
            'description' => esc_html__( 'Select `none` to hide icon. `left` to left align & `right` to right align', 'et_builder' ),
            'show_if'     => [],
            'default'     => $this->get_default( 'icon_placement' ),
        ];
        $fields['icon_set'] = [
            'label'       => esc_html__( 'Select Icon Set', 'et_builder' ),
            'type'        => 'select',
            'options'     => [
            'plus-minus'        => 'Plus & Minus',
            'plus-minus-square' => 'Plus & Minus Square (Premium)',
            'plus-minus-circle' => 'Plus & Minus Circle (Premium)',
            'single-chevron'    => 'Single Chevron (Premium)',
            'double-chevron'    => 'Double Chevron (Premium)',
        ],
            'tab_slug'    => 'advanced',
            'toggle_slug' => 'faq-icon',
            'description' => esc_html__( 'Select the icon set for the faq open and close', 'et_builder' ),
            'show_if_not' => [
            'icon_placement' => 'none',
        ],
            'default'     => $this->get_default( 'icon_set' ),
        ];
        $fields['icon_color_close'] = [
            'label'       => esc_html__( 'Color when close', 'et_builder' ),
            'type'        => 'color-alpha',
            'tab_slug'    => 'advanced',
            'toggle_slug' => 'faq-icon',
            'description' => esc_html__( 'Select icon color when faq item is close.', 'et_builder' ),
            'show_if_not' => [
            'icon_placement' => 'none',
        ],
            'default'     => $this->get_default( 'icon_color_close' ),
        ];
        $fields['icon_color_open'] = [
            'label'       => esc_html__( 'Color when open', 'et_builder' ),
            'type'        => 'color-alpha',
            'tab_slug'    => 'advanced',
            'toggle_slug' => 'faq-icon',
            'description' => esc_html__( 'Select icon color when faq item is open.', 'et_builder' ),
            'show_if_not' => [
            'icon_placement' => 'none',
        ],
            'default'     => $this->get_default( 'icon_color_open' ),
        ];
        $fields = $fields + $margin_padding->get_margin_padding_field(
            'category_title',
            'advanced',
            'category_title',
            '0|0|0|0',
            '20px|0|20px|0'
        );
        $fields = $fields + $margin_padding->get_margin_padding_field(
            'faq_list',
            'advanced',
            'faq_list',
            '0|0|0|0',
            '0|0|0|0'
        );
        $fields = $fields + $margin_padding->get_margin_padding_field(
            'faq_item',
            'advanced',
            'faq_item',
            '0|0|20px|0',
            '0|0|0|0'
        );
        $fields = $fields + $margin_padding->get_margin_padding_field(
            'faq_question',
            'advanced',
            'faq_question',
            '0|0|0|0',
            '0|0|20px|0'
        );
        $fields = $fields + $margin_padding->get_margin_padding_field(
            'faq_answer',
            'advanced',
            'faq_answer',
            '0|0|0|0',
            '20px|0|20px|0'
        );
        $fields = $fields + $border->get_border_fields(
            'faq_list',
            'advanced',
            'faq_list',
            '0|0|0|0|rgba(255,255,255,0)|solid'
        );
        $fields = $fields + $border->get_border_fields(
            'faq_item',
            'advanced',
            'faq_item',
            '0|0|0|0|rgba(255,255,255,0)|solid'
        );
        $fields = $fields + $border->get_border_fields(
            'faq_question',
            'advanced',
            'faq_question',
            '0|0|1px|0|#f0f1f5|solid'
        );
        $fields['question_text_color_open'] = [
            'label'       => esc_html__( 'Text Color - FAQ Open', 'et_builder' ),
            'type'        => 'color-alpha',
            'tab_slug'    => 'advanced',
            'toggle_slug' => 'faq_question',
            'priority'    => -100,
            'default'     => $this->get_default( 'question_text_color_open' ),
        ];
        $fields['update_browser_url'] = [
            'label'       => esc_html__( 'Change Browser URL On FAQ Click', 'et_builder' ),
            'type'        => 'yes_no_button',
            'options'     => [
            'off' => esc_html__( 'Off', 'et_builder' ),
            'on'  => esc_html__( 'On', 'et_builder' ),
        ],
            'tab_slug'    => 'advanced',
            'toggle_slug' => 'browser_behavior',
            'description' => esc_html__( 'Change the link of the browser when a faq item is clicked. Set "On" to enable this behavior. Set "Off" to disable this behavior. It`s recommended to keep it "On"', 'et_builder' ),
            'show_if'     => [],
            'default'     => $this->get_default( 'update_browser_url' ),
        ];
        return $fields;
    }
    
    public function _render_module_wrapper( $output = '', $render_slug = '' )
    {
        $output = parent::_render_module_wrapper( $output, $render_slug );
        $output = trim( $output );
        // remove starting and ending divs
        $output = substr_replace(
            $output,
            '<section',
            0,
            4
        );
        $output = substr_replace(
            $output,
            '/section>',
            strlen( $output ) - 5,
            5
        );
        return $output;
    }
    
    /**
     * Render the divi module
     */
    public function render( $attrs, $content = null, $render_slug )
    {
        $module_classes = $this->module_classname( $render_slug );
        $module_class = trim( ET_Builder_Element::add_module_order_class( '', $render_slug ) );
        $module_id = $this->module_id( false );
        if ( !$module_id ) {
            $module_id = $module_class;
        }
        $defaults = $this->get_defaults_props();
        $shortcode_attrs = shortcode_atts( $defaults, $attrs );
        $css = $this->get_custom_css( $shortcode_attrs, $this->props );
        ET_Builder_Element::set_style( $render_slug, [
            'selector'    => "#{$module_id}.wpt-faq-accordion",
            'declaration' => $css,
        ] );
        ET_Builder_Element::set_style( $render_slug, [
            'selector'    => "#{$module_id} ul.wpt-faq-accordion-list li div.wpt-faq-item[data-wpt-faq-state=open] .wpt-faq-question-text",
            'declaration' => sprintf( 'color:%s !important;', $shortcode_attrs['question_text_color_open'] ),
        ] );
        $margin_padding = new MarginPadding();
        $margin_padding->responsive_margin_padding(
            $this->props,
            'category_title',
            "#{$module_id} .wpt-faq-category",
            $render_slug
        );
        $margin_padding->responsive_margin_padding(
            $this->props,
            'faq_list',
            "#{$module_id} .wpt-faq-accordion-list",
            $render_slug
        );
        $margin_padding->responsive_margin_padding(
            $this->props,
            'faq_item',
            "#{$module_id} .wpt-faq-item",
            $render_slug
        );
        $margin_padding->responsive_margin_padding(
            $this->props,
            'faq_question',
            "#{$module_id} .wpt-faq-question",
            $render_slug
        );
        $margin_padding->responsive_margin_padding(
            $this->props,
            'faq_answer',
            "#{$module_id} div.wpt-faq-item[data-wpt-faq-state=open] .wpt-faq-answer",
            $render_slug
        );
        $shortcode = sprintf(
            '[wpt_faqs filter_by_categories="%s" categories="%s" group_by_categories="%s" category_name_html_tag="%s" post__in="%s" post__not_in="%s" faqs_per_page="%s" orderby="%s" order="%s" expand="%s" can_open="%s" icon_placement="%s" icon_set="%s" style_preset="%s" icon_color_open="%s" icon_color_close="%s" css_id="%s" update_browser_url="%s"/]',
            ( $shortcode_attrs['filter_by_categories'] == 'on' ? '1' : '0' ),
            $shortcode_attrs['categories'],
            ( $shortcode_attrs['group_by_categories'] == 'on' ? '1' : '0' ),
            ( isset( $this->props['category_title_level'] ) ? $this->props['category_title_level'] : $shortcode_attrs['category_name_html_tag'] ),
            $shortcode_attrs['post__in'],
            $shortcode_attrs['post__not_in'],
            $shortcode_attrs['faqs_per_page'],
            $shortcode_attrs['orderby'],
            $shortcode_attrs['order'],
            ( $shortcode_attrs['expand'] == 'on' ? '1' : '0' ),
            $shortcode_attrs['can_open'],
            $shortcode_attrs['icon_placement'],
            $shortcode_attrs['icon_set'],
            'none',
            $shortcode_attrs['icon_color_open'],
            $shortcode_attrs['icon_color_close'],
            $module_id,
            ( $shortcode_attrs['update_browser_url'] == 'on' ? '1' : '0' )
        );
        return do_shortcode( $shortcode );
    }
    
    public function get_custom_css( $attrs, $props )
    {
        $css = '';
        $vars = [
            '--wpt-faq-tg-icon-stroke-open'  => $attrs['icon_color_open'],
            '--wpt-faq-tg-icon-fill-open'    => $attrs['icon_color_open'],
            '--wpt-faq-tg-icon-stroke-close' => $attrs['icon_color_close'],
            '--wpt-faq-tg-icon-fill-close'   => $attrs['icon_color_close'],
            '--wpt-faq-tg-question-c-open'   => $attrs['question_text_color_open'],
            '--wpt-faq-tg-question-c'        => $attrs['question_text_color_close'],
            '--wpt-faq-tg-question-fsize'    => $attrs['question_font_size'],
        ];
        $border = new Border();
        $vars = $vars + $border->get_css_variables( $props, 'faq_item', '--wpt-faq-tg-item' );
        $vars = $vars + $border->get_css_variables( $props, 'faq_list', '--wpt-faq-tg-ul' );
        $vars = $vars + $border->get_css_variables( $props, 'faq_question', '--wpt-faq-tg-question' );
        foreach ( $vars as $key => $value ) {
            $css .= sprintf( "%s : %s;\n", $key, $value );
        }
        return $css;
    }
    
    /**
     * Get default value.
     */
    public function get_default( $name )
    {
        $defaults = $this->get_defaults_props();
        if ( isset( $defaults[$name] ) ) {
            return $defaults[$name];
        }
        return '';
    }
    
    /**
     * Get default values.
     */
    public function get_defaults_props()
    {
        return [
            'filter_by_categories'          => 'off',
            'categories'                    => '',
            'group_by_categories'           => 'off',
            'category_name_html_tag'        => 'h3',
            'post__in'                      => '',
            'post__not_in'                  => '',
            'faqs_per_page'                 => -1,
            'orderby'                       => 'date',
            'order'                         => 'ASC',
            'css_id'                        => 'wpt-faqs',
            'module_id'                     => 'wpt-faqs',
            'css_classes'                   => '',
            'expand'                        => 'off',
            'can_open'                      => 'one',
            'icon_placement'                => 'left',
            'icon_set'                      => 'plus-minus',
            'style_preset'                  => 'default',
            'icon_color_open'               => '#4c8bf5',
            'icon_color_close'              => '#4c8bf5',
            'question_text_color_close'     => '#2f3b48',
            'question_text_color_open'      => '#4c8bf5',
            'category_title_letter_spacing' => '1px',
            'category_title_text_align'     => 'left',
            'category_title_text_color'     => '#000000',
            'category_title_line_height'    => '1.5em',
            'category_title_font'           => '|700||on|||||',
            'category_title_font_size'      => '22px',
            'question_text_align'           => 'left',
            'question_text_color'           => '#2f3b48',
            'question_font_size'            => '17px',
            'update_browser_url'            => 'on',
        ];
    }

}
new FMFD_FaqManagerFaqModule();